package org.yodatomato.jsonitro.sample;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.ArrayList;

import org.ydtmt.jsonitro.HierarchyLevel;
import org.ydtmt.jsonitro.JSON;
import org.ydtmt.jsonitro.JSONitroHierarchySet;
import org.yodatomato.jsonitro.sample.bean.hatenahaiku.Reply;
import org.yodatomato.jsonitro.sample.bean.hatenahaiku.Status;
import org.yodatomato.jsonitro.sample.bean.hatenahaiku.User;

public class JSONitroSampleMain {
    public static void main(String[] args) throws Exception {
        JSONitroSampleMain main = new JSONitroSampleMain();
        JSON json = new JSON();
        // twitter
        ArrayList<?> obj = (ArrayList<?>) json.eval(main.getText("http://twitter.com/statuses/public_timeline.json"), null);
        System.out.println("twitter:" + obj);

        // Hatena Haiku
        JSONitroHierarchySet set = new JSONitroHierarchySet();
        try {
            set.addHierarchy(HierarchyLevel.LEVEL_0, ArrayList.class, JSONitroHierarchySet.PARENT);
            set.addHierarchy(HierarchyLevel.LEVEL_1, Status.class, JSONitroHierarchySet.PARENT);
            set.addHierarchy(HierarchyLevel.LEVEL_2, ArrayList.class, "replies");
            set.addHierarchy(HierarchyLevel.LEVEL_2, User.class, "user");
            set.addHierarchy(HierarchyLevel.LEVEL_3, Reply.class, "replies");
            set.addHierarchy(HierarchyLevel.LEVEL_4, User.class, "user");
            long cur = System.currentTimeMillis();
            obj = (ArrayList<?>) json.eval(main.getText("http://h.hatena.ne.jp/api/statuses/public_timeline.json"), set);
            System.out.println("time1:" + (System.currentTimeMillis() - cur));
            System.out.println("hatena haiku:" + obj);
            Status status = (Status) obj.get(0);
            User user = status.getUser();
            System.out.println("text:" + status.getText());
            System.out.println("user:" + user.getScreen_name());

        } catch (Exception e) {
            e.printStackTrace();
        }

    }

    private String getText(String urltext) throws Exception {
        long cur = System.currentTimeMillis();
        URL url = new URL(urltext);
        HttpURLConnection conn = (HttpURLConnection) url.openConnection();
        conn.setRequestMethod("GET");
        conn.connect();
        BufferedReader reader =
            new BufferedReader(new InputStreamReader(conn.getInputStream()));
        System.out.println("getText()-connect time:" + (System.currentTimeMillis() - cur));
        StringBuilder sb = new StringBuilder();
        while (true) {
            String line = reader.readLine();
            if ( line == null ){
                break;
            }
            sb.append(line);
        }
        System.out.println("getText()-return time:" + (System.currentTimeMillis() - cur));
        return sb.toString();
    }

}
